<?php
//-----------------------------------------
// OpenCart Table Rate Shipping Module
// Version: 1.0
// Author: Watershed Studio	
// Email: opencart@watershedstudio.com
// Web: http://www.watershedstudio.com/
//-----------------------------------------

class ControllerShippingTableRate extends Controller { 
	private $error = array();
	
	public function index() {  
		$this->load->language('shipping/table_rate');

		$this->document->title = $this->language->get('heading_title');
		
		$this->load->model('setting/setting');
				 
		if (($this->request->server['REQUEST_METHOD'] == 'POST') && ($this->validate())) {
			$this->model_setting_setting->editSetting('table_rate', $this->request->post);	

			$this->session->data['success'] = $this->language->get('text_success');
									
			$this->redirect($this->url->https('extension/shipping'));
		}
		
		$this->data['heading_title'] = $this->language->get('heading_title');

		$this->data['text_none'] = $this->language->get('text_none');
		$this->data['text_enabled'] = $this->language->get('text_enabled');
		$this->data['text_disabled'] = $this->language->get('text_disabled');
		
		$this->data['entry_rate'] = $this->language->get('entry_rate');
		$this->data['entry_tax'] = $this->language->get('entry_tax');
		$this->data['entry_status'] = $this->language->get('entry_status');
		$this->data['entry_sort_order'] = $this->language->get('entry_sort_order');
		
		$this->data['button_save'] = $this->language->get('button_save');
		$this->data['button_cancel'] = $this->language->get('button_cancel');

		$this->data['tab_general'] = $this->language->get('tab_general');

 		if (isset($this->error['warning'])) {
			$this->data['error_warning'] = $this->error['warning'];
		} else {
			$this->data['error_warning'] = '';
		}

  		$this->document->breadcrumbs = array();

   		$this->document->breadcrumbs[] = array(
       		'href'      => $this->url->https('common/home'),
       		'text'      => $this->language->get('text_home'),
      		'separator' => FALSE
   		);

   		$this->document->breadcrumbs[] = array(
       		'href'      => $this->url->https('extension/shipping'),
       		'text'      => $this->language->get('text_shipping'),
      		'separator' => ' :: '
   		);
		
   		$this->document->breadcrumbs[] = array(
       		'href'      => $this->url->https('shipping/table_rate'),
       		'text'      => $this->language->get('heading_title'),
      		'separator' => ' :: '
   		);
		
		$this->data['action'] = $this->url->https('shipping/table_rate');
		
		$this->data['cancel'] = $this->url->https('extension/shipping'); 

		$this->load->model('localisation/geo_zone');
		
		$geo_zones = $this->model_localisation_geo_zone->getGeoZones();
		
		foreach ($geo_zones as $geo_zone) {
			if (isset($this->request->post['table_rate_' . $geo_zone['geo_zone_id'] . '_rate'])) {
				$this->data['table_rate_' . $geo_zone['geo_zone_id'] . '_rate'] = $this->request->post['table_rate_' . $geo_zone['geo_zone_id'] . '_rate'];
			} else {
				$this->data['table_rate_' . $geo_zone['geo_zone_id'] . '_rate'] = $this->config->get('table_rate_' . $geo_zone['geo_zone_id'] . '_rate');
			}		
			
			if (isset($this->request->post['table_rate_' . $geo_zone['geo_zone_id'] . '_status'])) {
				$this->data['table_rate_' . $geo_zone['geo_zone_id'] . '_status'] = $this->request->post['table_rate_' . $geo_zone['geo_zone_id'] . '_status'];
			} else {
				$this->data['table_rate_' . $geo_zone['geo_zone_id'] . '_status'] = $this->config->get('table_rate_' . $geo_zone['geo_zone_id'] . '_status');
			}		
		}
		
		$this->data['geo_zones'] = $geo_zones;

		if (isset($this->request->post['table_rate_tax_class_id'])) {
			$this->data['table_rate_tax_class_id'] = $this->request->post['table_rate_tax_class_id'];
		} else {
			$this->data['table_rate_tax_class_id'] = $this->config->get('table_rate_tax_class_id');
		}
		
		if (isset($this->request->post['table_rate_status'])) {
			$this->data['table_rate_status'] = $this->request->post['table_rate_status'];
		} else {
			$this->data['table_rate_status'] = $this->config->get('table_rate_status');
		}
		
		if (isset($this->request->post['table_rate_sort_order'])) {
			$this->data['table_rate_sort_order'] = $this->request->post['table_rate_sort_order'];
		} else {
			$this->data['table_rate_sort_order'] = $this->config->get('table_rate_sort_order');
		}	
		
		$this->load->model('localisation/tax_class');
				
		$this->data['tax_classes'] = $this->model_localisation_tax_class->getTaxClasses();
								
		$this->id       = 'content';
		$this->template = 'shipping/table_rate.tpl';
		$this->layout   = 'common/layout';
		
 		$this->render();
	}
		
	private function validate() {
		if (!$this->user->hasPermission('modify', 'shipping/table_rate')) {
			$this->error['warning'] = $this->language->get('error_permission');
		}
		
		if (!$this->error) {
			return TRUE;
		} else {
			return FALSE;
		}	
	}
}
?>